import { objectWithoutProperties as _objectWithoutProperties, extends as _extends } from '../../../_virtual/_rollupPluginBabelHelpers.js';
import React__default from 'react';
import Item from '../Item/index.js';
import { Popper } from '@mui/material';
import { SidemenuModalWrapper } from './style.js';
import { ThemeProvider } from 'styled-components';
import theme from '../../../Globals/theme.js';
import globalStyle from '../../../Globals/global-styles.js';

var _excluded = ["children", "items", "open"];

var PopperMenu = function PopperMenu(_ref) {
  var children = _ref.children,
      _ref$items = _ref.items,
      items = _ref$items === void 0 ? [] : _ref$items,
      _ref$open = _ref.open,
      open = _ref$open === void 0 ? false : _ref$open,
      rest = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/React__default.createElement(ThemeProvider, {
    theme: theme
  }, /*#__PURE__*/React__default.createElement(React__default.Fragment, null, /*#__PURE__*/React__default.createElement(globalStyle, null), /*#__PURE__*/React__default.createElement(Popper, _extends({}, rest, {
    id: "pop-menu",
    open: open
  }), function () {
    return /*#__PURE__*/React__default.createElement(SidemenuModalWrapper, null, items && items.map(function (item, index) {
      return /*#__PURE__*/React__default.createElement(Item, {
        item: item,
        key: index
      });
    }), children);
  })));
};

export { PopperMenu as default };
//# sourceMappingURL=index.js.map
